

import java.lang.reflect.Method;

import be.tarsos.dsp.pitch.PitchDetectionResult;
import be.tarsos.dsp.pitch.Yin;

import com.cycling74.max.Atom;
import com.cycling74.max.DataTypes;
import com.cycling74.msp.MSPObject;
import com.cycling74.msp.MSPSignal;

public class tarsosdsppitch  extends MSPObject {
	
	private Yin yin;
	private float[] audioBuffer;
	private int waterMark;
	
	public tarsosdsppitch(){
		//The signal
		 declareInlets( new int[] { SIGNAL } );
		 // A pitch in Hertz
	     declareOutlets( new int[] {DataTypes.FLOAT} );
	}

	public Method dsp(MSPSignal[] ins, MSPSignal[] outs) {
		System.out.println("Initializing pitch detection");
		
		int bufferSize = 1024;
		yin = new Yin((float)ins[0].sr, bufferSize);
		audioBuffer = new float[bufferSize];
		
        return getPerformMethod("doit");
    }
    
	public void loadbang(){
		System.out.println("Load bang!");
	}
	
    public void doit(MSPSignal[] ins, MSPSignal[] outs) {
        
       float[] mspAudioBuffer = ins[0].vec;
       
       
       // Shift the array so that there is room for new samples at the end
       for(int i = 0 ; i < audioBuffer.length - mspAudioBuffer.length;i++){
    	   audioBuffer[i] = audioBuffer[i+mspAudioBuffer.length];
       }
      //Copy the new samples to the end of the buffer       
       int j = 0;
       for(int i = audioBuffer.length - mspAudioBuffer.length ; i < audioBuffer.length;i++){
    	   audioBuffer[i] = mspAudioBuffer[j];
    	   j++;
       }
       
       
       waterMark += mspAudioBuffer.length;
       //if there is at least one complete buffer, estimate pitch
       float pitch = 0;
       if(waterMark>= audioBuffer.length){
    	   PitchDetectionResult result = yin.getPitch(audioBuffer);
    	   pitch = result.getPitch();
       }
       
       //System.out.println("Detected pitch of " + pitch + "Hz");
       
       outlet(0, Atom.newAtom(pitch));
    }

}
